import { __decorate } from 'tslib';
import { Pipe, NgModule } from '@angular/core';

let SearchByPipe = class SearchByPipe {
    transform(value, searchWord, propertiesForSearch, sensitive = true) {
        const array = [];
        const indexes = [];
        if (searchWord) {
            if (searchWord !== '' && searchWord !== null) {
                if (sensitive) {
                    propertiesForSearch.map((property) => {
                        value.map((val, index) => {
                            if (indexes.indexOf(index) === -1) {
                                const result = this.searchInByString(val, property);
                                if (result) {
                                    if (result.toLowerCase().indexOf(searchWord.toLowerCase()) > -1) {
                                        array.push(val);
                                        indexes.push(index);
                                    }
                                }
                            }
                        });
                    });
                    return array;
                }
                else {
                    propertiesForSearch.map((property) => {
                        value.forEach((val, index) => {
                            if (indexes.indexOf(index) === -1) {
                                const result = this.searchInByString(val, property);
                                if (result) {
                                    if (result.indexOf(searchWord.toLowerCase()) > -1) {
                                        array.push(val);
                                        indexes.push(index);
                                    }
                                }
                            }
                        });
                    });
                    return array;
                }
            }
        }
        return value;
    }
    searchInByString(obj = {}, properties, value) {
        const keys = properties.split('.');
        if (value) {
            return value;
        }
        else {
            const type = typeof obj[keys[0]];
            if (type === 'string' || type === 'number' || type === 'boolean') {
                value = obj[keys[0]];
                return this.searchInByString({}, '', value);
            }
            if (type === 'object') {
                let newObj = {};
                newObj = Object.assign(newObj, obj[keys[0]]);
                keys.splice(0, 1);
                const newProperties = keys.join('.');
                return this.searchInByString(newObj, newProperties);
            }
        }
    }
};
SearchByPipe = __decorate([
    Pipe({
        name: 'searchBy'
    })
], SearchByPipe);

let PipeSearchByModule = class PipeSearchByModule {
};
PipeSearchByModule = __decorate([
    NgModule({
        declarations: [SearchByPipe],
        imports: [],
        exports: [SearchByPipe]
    })
], PipeSearchByModule);

/*
 * Public API Surface of search-by
 */

/**
 * Generated bundle index. Do not edit.
 */

export { PipeSearchByModule, SearchByPipe as ɵa };
//# sourceMappingURL=ngx-pipe-search-by.js.map
